## htslib 1.22.1+ds

=== debian/changelog ===
htslib (1.22.1+ds-2) unstable; urgency=medium

  * d/htslib-test.install: also install ref_cache/*.[ch]. Closes:
    #1111788

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 03 Sep 2025 20:45:19 +0200

htslib (1.22.1+ds-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * d/copyright: Also excluding config.{guess,sub}

 -- Steffen Moeller <moeller@debian.org>  Sun, 17 Aug 2025 21:04:46 +0200
