=== debian/control ===
Source: htslib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Steffen Moeller <moeller@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               libbz2-dev,
               libcurl4-gnutls-dev,
               liblzma-dev,
               libssl-dev,
               zlib1g-dev,
               libdeflate-dev,
               libhtscodecs-dev (>= 1.0)
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/htslib
Vcs-Git: https://salsa.debian.org/med-team/htslib.git
Homepage: https://github.com/samtools/htslib
Rules-Requires-Root: no

Package: libhts3t64
Provides: ${t64:Provides}
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libhts3 (<< ${source:Version}),
        libtabixpp (<< 1.0.0-5~),
        libhts-dev (<< 1.13~),
        samtools (<< 1.17~),
        ivar (<< 1.3.1~)
Replaces: libhts3, libhts-dev (<< 1.13~)
Description: C library for high-throughput sequencing data formats
 HTSlib is an implementation of a unified C library for accessing common file
 formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
 Format), used for high-throughput sequencing data, and is the core library
 used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
 compatible with gcc, g++ and clang.
 .
 HTSlib implements a generalized BAM (binary SAM) index, with file extension
 ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
 new index and then for the old if the new index is absent.

Package: libhts-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libbz2-dev,
         libhts3t64 (= ${binary:Version}),
         libcurl4-gnutls-dev,
         libdeflate-dev,
         liblzma-dev,
         zlib1g-dev,
         ${misc:Depends}
Description: development files for the HTSlib
 HTSlib is an implementation of a unified C library for accessing common file
 formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
 Format), used for high-throughput sequencing data, and is the core library
 used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
 compatible with gcc, g++ and clang.
 .
 HTSlib implements a generalized BAM (binary SAM) index, with file extension
 ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
 new index and then for the old if the new index is absent.
 .
 This package contains development files for the HTSlib: headers, static
 library, manual pages, etc.
 .
 For compatibility with sambamba, the internal routine cram_to_bam was
 exported, hereto adopting a patch found in guix.

Package: htslib-test
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${perl:Depends}
Description: Test data for HTSlib
 HTSlib is an implementation of a unified C library for accessing common file
 formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
 Format), used for high-throughput sequencing data, and is the core library
 used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
 compatible with gcc, g++ and clang.
 .
 HTSlib implements a generalized BAM (binary SAM) index, with file extension
 ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
 new index and then for the old if the new index is absent.
 .
 This package contains test files and scripts for the HTSlib.

Package: tabix
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: generic indexer for TAB-delimited genome position files
 Tabix indexes files where some columns indicate sequence coordinates: name
 (usually a chromosome), start and stop. The input data file must be position
 sorted and compressed by bgzip (provided in this package), which has a gzip
 like interface. After indexing, tabix is able to quickly retrieve data lines by
 chromosomal coordinates. Fast data retrieval also works over network if an URI
 is given as a file name.
 .
 This package is built from the HTSlib source, and provides the bgzip, htsfile,
 and tabix tools.
