## htslib 1.22.1+ds2

=== Makefile ===
# Makefile for htslib, a C library for high-throughput sequencing data formats.
#
#    Copyright (C) 2013-2024 Genome Research Ltd.
#
#    Author: John Marshall <jm18@sanger.ac.uk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.

CC     = gcc
AR     = ar
RANLIB = ranlib

# Default libraries to link if configure is not used
htslib_default_libs = -lz -lm -lbz2 -llzma -lcurl

CPPFLAGS =
# TODO: make the 64-bit support for VCF optional via configure, for now add -DVCF_ALLOW_INT64
#       to CFLAGS manually, here or in config.mk if the latter exists.
# TODO: probably update cram code to make it compile cleanly with -Wc++-compat
# For testing strict C99 support add -std=c99 -D_XOPEN_SOURCE=600
#CFLAGS   = -g -Wall -O2 -pedantic -std=c99 -D_XOPEN_SOURCE=600
CFLAGS   = -g -Wall -O2 -fvisibility=hidden
EXTRA_CFLAGS_PIC = -fpic
TARGET_CFLAGS =
LDFLAGS  = -fvisibility=hidden
VERSION_SCRIPT_LDFLAGS = -Wl,-version-script,$(srcprefix)htslib.map
LIBS     = $(htslib_default_libs)

prefix      = /usr/local
exec_prefix = $(prefix)
bindir      = $(exec_prefix)/bin
includedir  = $(prefix)/include
libdir      = $(exec_prefix)/lib
libexecdir  = $(exec_prefix)/libexec
datarootdir = $(prefix)/share
mandir      = $(datarootdir)/man
man1dir     = $(mandir)/man1
man5dir     = $(mandir)/man5
man7dir     = $(mandir)/man7
pkgconfigdir= $(libdir)/pkgconfig

MKDIR_P = mkdir -p
INSTALL = install -p
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_DIR     = $(MKDIR_P) -m 755
LIB_PERM        = 644
INSTALL_LIB     = $(INSTALL) -m $(LIB_PERM)
INSTALL_MAN     = $(INSTALL_DATA)
INSTALL_PROGRAM = $(INSTALL)

# Set by config.mk if plugins are enabled
plugindir =

BUILT_PROGRAMS = \
	annot-tsv \
	bgzip \
	htsfile \
	tabix

BUILT_TEST_PROGRAMS = \
	test/hts_endian \
	test/fieldarith \
	test/hfile \
	test/pileup \
	test/pileup_mod \
	test/plugins-dlhts \
	test/sam \
	test/test_bgzf \
	test/test_expr \
	test/test_faidx \
	test/test_kfunc \
	test/test_khash \
	test/test_kstring \
	test/test_mod \
	test/test_nibbles \
	test/test_realn \
	test/test-regidx \
	test/test_str2int \
	test/test_time_funcs \
	test/test_view \
	test/test_index \
	test/test-vcf-api \
	test/test-vcf-sweep \
	test/test-bcf-sr \
	test/fuzz/hts_open_fuzzer.o \
	test/test-bcf-translate \
	test/test-parse-reg \
	test/test_introspection \
	test/test-bcf_set_variant_type

BUILT_THRASH_PROGRAMS = \
	test/thrash_threads1 \
	test/thrash_threads2 \
	test/thrash_threads3 \
	test/thrash_threads4 \
	test/thrash_threads5 \
	test/thrash_threads6 \
	test/thrash_threads7

all: lib-static lib-shared $(BUILT_PROGRAMS) plugins \
	$(BUILT_TEST_PROGRAMS) htslib_static.mk htslib-uninstalled.pc

# Report compiler and version
cc-version:
	-@$(CC) --version  2>/dev/null || true
	-@$(CC) --qversion 2>/dev/null || true
	-@$(CC) -V         2>/dev/null || true

ALL_CPPFLAGS = -I. $(CPPFLAGS)

# Usually htscodecs.mk is generated by running configure or config.status,
# but if those aren't used create a default here.
htscodecs.mk:
	echo '# Default htscodecs.mk generated by Makefile' > $@
	echo 'include $$(HTSPREFIX)htscodecs_bundled.mk' >> $@
	$(srcdir)/hts_probe_cc.sh '$(CC)' '$(CFLAGS) $(CPPFLAGS)' '$(LDFLAGS)' >> $@

srcdir = .
srcprefix =
HTSPREFIX =

# Flags for SIMD code
HTS_CFLAGS_AVX2 =
HTS_CFLAGS_AVX512 =
HTS_CFLAGS_SSE4 =

# Control building of SIMD code.  Not used if configure has been run.
HTS_BUILD_AVX2 =
HTS_BUILD_AVX512 =
HTS_BUILD_SSE4 =

include htslib_vars.mk
include htscodecs.mk

# If not using GNU make, you need to copy the version number from version.sh
# into here.
PACKAGE_VERSION := $(shell $(srcdir)/version.sh)

LIBHTS_SOVERSION = 3

# Version numbers for the Mac dynamic library.  Note that the leading 3
# is not strictly necessary and should be removed the next time
# LIBHTS_SOVERSION is bumped (see #1144 and
# https://developer.apple.com/library/archive/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html#//apple_ref/doc/uid/TP40002013-SW23)
MACH_O_COMPATIBILITY_VERSION = 3.1.22
MACH_O_CURRENT_VERSION = 3.1.22

# Force version.h to be remade if $(PACKAGE_VERSION) has changed.
version.h: $(if $(wildcard version.h),$(if $(findstring "$(PACKAGE_VERSION)",$(shell cat version.h)),,force))

version.h:
	echo '#define HTS_VERSION_TEXT "$(PACKAGE_VERSION)"' > $@

print-version:
	@echo $(PACKAGE_VERSION)

show-version:
	@echo PACKAGE_VERSION = $(PACKAGE_VERSION)

config_vars.h: override escape=$(subst ',\x27,$(subst ",\",$(subst \,\\,$(1))))
config_vars.h: override hts_cc_escaped=$(call escape,$(CC))
config_vars.h: override hts_cppflags_escaped=$(call escape,$(CPPFLAGS))
config_vars.h: override hts_cflags_escaped=$(call escape,$(CFLAGS))
config_vars.h: override hts_ldflags_escaped=$(call escape,$(LDFLAGS))
config_vars.h: override hts_libs_escaped=$(call escape,$(LIBS))

config_vars.h:
	printf '#define HTS_CC "%s"\n#define HTS_CPPFLAGS "%s"\n#define HTS_CFLAGS "%s"\n#define HTS_LDFLAGS "%s"\n#define HTS_LIBS "%s"\n' \
	'$(hts_cc_escaped)' \
	'$(hts_cppflags_escaped)' \
	'$(hts_cflags_escaped)' \
	'$(hts_ldflags_escaped)' \
	'$(hts_libs_escaped)' > $@

.SUFFIXES: .bundle .c .cygdll .dll .o .pico .so

.c.o:
	$(CC) $(CFLAGS) $(TARGET_CFLAGS) $(ALL_CPPFLAGS) -c -o $@ $<

.c.pico:
	$(CC) $(CFLAGS) $(TARGET_CFLAGS) $(ALL_CPPFLAGS) $(EXTRA_CFLAGS_PIC) -c -o $@ $<

ref_cache/%.o: ref_cache/%.c
	$(CC) $(CFLAGS) $(REF_CACHE_EXTRA_C_FLAGS) $(TARGET_CFLAGS) $(ALL_CPPFLAGS) -c -o $@ $<

LIBHTS_OBJS = \
	kfunc.o \
	kstring.o \
	bcf_sr_sort.o \
	bgzf.o \
	errmod.o \
	faidx.o \
	header.o \
	hfile.o \
	hts.o \
	hts_expr.o \
	hts_os.o\
	md5.o \
	multipart.o \
	probaln.o \
	realn.o \
	regidx.o \
	region.o \
	sam.o \
	sam_mods.o \
	simd.o \
	synced_bcf_reader.o \
	vcf_sweep.o \
	tbx.o \
	textutils.o \
	thread_pool.o \
	vcf.o \
	vcfutils.o \
	cram/cram_codecs.o \
	cram/cram_decode.o \
	cram/cram_encode.o \
	cram/cram_external.o \
	cram/cram_index.o \
	cram/cram_io.o \
	cram/cram_stats.o \
	cram/mFILE.o \
	cram/open_trace_file.o \
	cram/pooled_alloc.o \
	cram/string_alloc.o \
	$(HTSCODECS_OBJS) \
	$(NONCONFIGURE_OBJS)

REF_CACHE_OBJS = ref_cache/cmsg_wrap.o \
        ref_cache/http_parser.o \
	ref_cache/listener.o \
	ref_cache/log_files.o \
	ref_cache/main.o \
	ref_cache/misc.o \
	ref_cache/ping.o \
	ref_cache/poll_wrap_epoll.o \
	ref_cache/poll_wrap_poll.o \
	ref_cache/ref_files.o \
	ref_cache/request_handler.o \
	ref_cache/sendfile_wrap.o \
	ref_cache/server.o \
	ref_cache/transaction.o \
	ref_cache/upstream.o \
	cram/pooled_alloc.o \
	md5.o

# Without configure we wish to have a rich set of default figures,
# but we still need conditional inclusion as we wish to still
# support ./configure --disable-blah.
NONCONFIGURE_OBJS = hfile_libcurl.o

PLUGIN_EXT  =
PLUGIN_OBJS =

cram_h = cram/cram.h $(cram_samtools_h) $(header_h) $(cram_structs_h) $(cram_io_h) cram/cram_encode.h cram/cram_decode.h cram/cram_stats.h cram/cram_codecs.h cram/cram_index.h $(htslib_cram_h)
cram_io_h = cram/cram_io.h $(cram_misc_h)
cram_misc_h = cram/misc.h
cram_os_h = cram/os.h $(htslib_hts_endian_h)
cram_samtools_h = cram/cram_samtools.h $(htslib_sam_h)
cram_structs_h = cram/cram_structs.h $(htslib_thread_pool_h) $(htslib_cram_h) cram/string_alloc.h cram/mFILE.h $(htslib_khash_h)
cram_open_trace_file_h = cram/open_trace_file.h cram/mFILE.h
bcf_sr_sort_h = bcf_sr_sort.h $(htslib_synced_bcf_reader_h) $(htslib_kbitset_h)
fuzz_settings_h = fuzz_settings.h
header_h = header.h cram/string_alloc.h cram/pooled_alloc.h $(htslib_khash_h) $(htslib_kstring_h) $(htslib_sam_h)
hfile_internal_h = hfile_internal.h $(htslib_hts_defs_h) $(htslib_hfile_h) $(textutils_internal_h)
hts_internal_h = hts_internal.h $(htslib_hts_h) $(textutils_internal_h)
hts_time_funcs_h = hts_time_funcs.h
sam_internal_h = sam_internal.h $(htslib_sam_h)
textutils_internal_h = textutils_internal.h $(htslib_kstring_h)
thread_pool_internal_h = thread_pool_internal.h $(htslib_thread_pool_h)

# To be effective, config.mk needs to appear after most Makefile variables are
# set but before most rules appear, so that it can both use previously-set
# variables in its own rules' prerequisites and also update variables for use
# in later rules' prerequisites.

# If your make doesn't accept -include, change this to 'include' if you are
# using the configure script or just comment the line out if you are not.
-include config.mk

# Add optional built programs here
all: $(REF_CACHE_PROGRAMS)

# Usually config.h is generated by running configure or config.status,
# but if those aren't used create a default config.h here.
config.h:
	echo '/* Default config.h generated by Makefile */' > $@
	echo '#ifndef _XOPEN_SOURCE' >> $@
	echo '#define _XOPEN_SOURCE 600' >> $@
	echo '#endif' >> $@
	echo '#define HAVE_LIBBZ2 1' >> $@
	echo '#define HAVE_LIBLZMA 1' >> $@
	echo '#ifndef __APPLE__' >> $@
	echo '#define HAVE_LZMA_H 1' >> $@
	echo '#endif' >> $@
	echo '#define HAVE_DRAND48 1' >> $@
	echo '#define HAVE_LIBCURL 1' >> $@
	if [ "x$(HTS_HAVE_CPUID)" != "x" ]; then \
	    echo '#define HAVE_DECL___CPUID_COUNT 1' >> $@ ; \
	    echo '#define HAVE_DECL___GET_CPUID_MAX 1' >> $@ ; \
	fi
	if [ "x$(HTS_BUILD_SSE4)" != "x" ]; then \
	    echo '#define HAVE_POPCNT 1' >> $@ ; \
	    echo '#define HAVE_SSE4_1 1' >> $@ ; \
	    echo '#define HAVE_SSSE3 1' >> $@ ; \
	    echo '#if defined(HTS_ALLOW_UNALIGNED) && HTS_ALLOW_UNALIGNED == 0' >> $@ ; \
	    echo '#define UBSAN 1' >> $@ ; \
	    echo '#endif' >> $@ ; \
	fi
	if [ "x$(HTS_BUILD_AVX2)" != "x" ] ; then \
	    echo '#define HAVE_AVX2 1' >> $@ ; \
	fi
	if [ "x$(HTS_BUILD_AVX512)" != "x" ] ; then \
	    echo '#define HAVE_AVX512 1' >> $@ ; \
	fi
	echo '#if defined __x86_64__ || defined __arm__ || defined __aarch64__' >> $@
	echo '#define HAVE_ATTRIBUTE_CONSTRUCTOR 1' >> $@
	echo '#endif' >> $@
	echo '#if (defined(__x86_64__) || defined(_M_X64))' >> $@
	echo '#define HAVE_ATTRIBUTE_TARGET_SSSE3 1' >> $@
	echo '#define HAVE_BUILTIN_CPU_SUPPORT_SSSE3 1' >> $@
	echo '#endif' >> $@
	echo '#if defined __linux__' >> $@
	echo '#define HAVE_GETAUXVAL' >> $@
	echo '#elif defined __FreeBSD__' >> $@
	echo '#define HAVE_ELF_AUX_INFO' >> $@
	echo '#elif defined __OpenBSD__' >> $@
	echo '// Enable extra OpenBSD checks (see simd.c)' >> $@
	echo '#define HAVE_OPENBSD' >> $@
	echo '#endif' >> $@

# And similarly for htslib.pc.tmp ("pkg-config template").  No dependency
# on htslib.pc.in listed, as if that file is newer the usual way to regenerate
# this target is via configure or config.status rather than this rule.
htslib.pc.tmp:
	sed -e '/^static_libs=/s/@static_LIBS@/$(htslib_default_libs)/;s#@[^-][^@]*@##g' $(srcprefix)htslib.pc.in > $@

# Create a makefile fragment listing the libraries and LDFLAGS needed for
# static linking.  This can be included by projects that want to build
# and link against the htslib source tree instead of an installed library.
htslib_static.mk: htslib.pc.tmp
	sed -n '/^static_libs=/s/[^=]*=/HTSLIB_static_LIBS = /p;/^static_ldflags=/s/[^=]*=/HTSLIB_static_LDFLAGS = /p' $< > $@
