=== debian/changelog ===
htslib (1.22.1+ds2-1) unstable; urgency=medium

  * Properly clean the upstream release tarball.
  * Don't ship architecture-specific files in htslib-test; regenerate
    them at test-time using autoconf.
  * d/libhts3t64.symbols: add new symbols for the latest release.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 04 Sep 2025 13:56:30 +0200
