=== debian/control ===
--- 
+++ 
@@ -7,14 +7,15 @@
            Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5),
+               debhelper-compat (= 13),
                libbz2-dev,
                libcurl4-gnutls-dev,
                liblzma-dev,
                libssl-dev,
                zlib1g-dev,
                libdeflate-dev,
-               libhtscodecs-dev (>= 1.0)
+               libhtscodecs-dev
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/htslib
 Vcs-Git: https://salsa.debian.org/med-team/htslib.git
@@ -22,7 +23,6 @@
 Rules-Requires-Root: no
 
 Package: libhts3t64
-Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -31,10 +31,9 @@
 Pre-Depends: ${misc:Pre-Depends}
 Breaks: libhts3 (<< ${source:Version}),
         libtabixpp (<< 1.0.0-5~),
-        libhts-dev (<< 1.13~),
-        samtools (<< 1.17~),
-        ivar (<< 1.3.1~)
-Replaces: libhts3, libhts-dev (<< 1.13~)
+        samtools (<< 1.17~)
+Provides: ${t64:Provides}
+Replaces: libhts3
 Description: C library for high-throughput sequencing data formats
  HTSlib is an implementation of a unified C library for accessing common file
  formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
