=== debian/tests/control ===
Tests: run-unit-test
Depends: @, build-essential, @builddeps@
Restrictions: allow-stderr
